#pragma once

#include once "CommonCrypto/CommonCrypto.bi"

extern "C"

#define HAD_ZIP_CRYPTO_COMMONCRYPTO_H
#define _zip_crypto_aes_t _CCCryptor
#define _zip_crypto_hmac_t CCHmacContext

declare sub _zip_crypto_aes_free(byval aes as _CCCryptor ptr)
declare function _zip_crypto_aes_encrypt_block(byval aes as _CCCryptor ptr, byval in as const zip_uint8_t ptr, byval out as zip_uint8_t ptr) as bool
declare function _zip_crypto_aes_new(byval key as const zip_uint8_t ptr, byval key_size as zip_uint16_t, byval error as zip_error_t ptr) as _CCCryptor ptr
#macro _zip_crypto_hmac(hmac, data, length)
	scope
		CCHmacUpdate((hmac), (data), (length))
		true
	end scope
#endmacro
declare sub _zip_crypto_hmac_free(byval hmac as CCHmacContext ptr)
declare function _zip_crypto_hmac_new(byval secret as const zip_uint8_t ptr, byval secret_length as zip_uint64_t, byval error as zip_error_t ptr) as CCHmacContext ptr
#macro _zip_crypto_hmac_output(hmac, data)
	scope
		CCHmacFinal((hmac), (data))
		true
	end scope
#endmacro
#define _zip_crypto_pbkdf2(key, key_length, salt, salt_length, iterations, output, output_length) (CCKeyDerivationPBKDF(kCCPBKDF2, cptr(const zstring ptr, (key)), (key_length), (salt), (salt_length), kCCPRFHmacAlgSHA1, (iterations), (output), (output_length)) = kCCSuccess)

end extern
