#pragma once

#include once "nettle/aes.bi"
#include once "nettle/pbkdf2.bi"
#include once "gnutls/gnutls.bi"
#include once "gnutls/crypto.bi"

extern "C"

#define HAD_ZIP_CRYPTO_GNUTLS_H

union _zip_crypto_aes_t_ctx
	ctx_128 as aes128_ctx
	ctx_192 as aes192_ctx
	ctx_256 as aes256_ctx
end union

type _zip_crypto_aes_t
	ctx as _zip_crypto_aes_t_ctx
	key_size as zip_uint16_t
end type

#define _zip_crypto_hmac_t gnutls_hmac_hd_t
declare sub _zip_crypto_aes_free(byval aes as _zip_crypto_aes_t ptr)
declare function _zip_crypto_aes_encrypt_block(byval aes as _zip_crypto_aes_t ptr, byval in as const zip_uint8_t ptr, byval out as zip_uint8_t ptr) as bool
declare function _zip_crypto_aes_new(byval key as const zip_uint8_t ptr, byval key_size as zip_uint16_t, byval error as zip_error_t ptr) as _zip_crypto_aes_t ptr
#define _zip_crypto_hmac(hmac, data, length) (gnutls_hmac(*(hmac), (data), (length)) = 0)
declare sub _zip_crypto_hmac_free(byval hmac as gnutls_hmac_hd_t ptr)
declare function _zip_crypto_hmac_new(byval secret as const zip_uint8_t ptr, byval secret_length as zip_uint64_t, byval error as zip_error_t ptr) as gnutls_hmac_hd_t ptr
#macro _zip_crypto_hmac_output(hmac, data)
	scope
		gnutls_hmac_output(*(hmac), (data))
		true
	end scope
#endmacro
#macro _zip_crypto_pbkdf2(key, key_length, salt, salt_length, iterations, output, output_length)
	scope
		pbkdf2_hmac_sha1((key_length), (key), (iterations), (salt_length), (salt), (output_length), (output))
		true
	end scope
#endmacro

end extern
