#pragma once

#include once "openssl/aes.bi"
#include once "openssl/hmac.bi"

extern "C"

#define HAD_ZIP_CRYPTO_OPENSSL_H
#define _zip_crypto_aes_t AES_KEY
#define _zip_crypto_hmac_t HMAC_CTX
declare sub _zip_crypto_aes_free(byval aes as AES_KEY ptr)
#macro _zip_crypto_aes_encrypt_block(aes, in, out)
	scope
		AES_encrypt((in), (out), (aes))
		true
	end scope
#endmacro
declare function _zip_crypto_aes_new(byval key as const zip_uint8_t ptr, byval key_size as zip_uint16_t, byval error as zip_error_t ptr) as AES_KEY ptr
#define _zip_crypto_hmac(hmac, data, length) (HMAC_Update((hmac), (data), (length)) = 1)

declare sub _zip_crypto_hmac_free(byval hmac as HMAC_CTX ptr)
declare function _zip_crypto_hmac_new(byval secret as const zip_uint8_t ptr, byval secret_length as zip_uint64_t, byval error as zip_error_t ptr) as HMAC_CTX ptr
declare function _zip_crypto_hmac_output(byval hmac as HMAC_CTX ptr, byval data as zip_uint8_t ptr) as bool
#define _zip_crypto_pbkdf2(key, key_length, salt, salt_length, iterations, output, output_length) PKCS5_PBKDF2_HMAC_SHA1(cptr(const zstring ptr, (key)), (key_length), (salt), (salt_length), (iterations), (output_length), (output))

end extern
